' MeasurePlugin
' Initial code generated by XSI SDK Wizard
' Executed Sat Mar 1 00:29:41 UTC 2008 by Crystal
' 
' UPDATED 13/04/2010 - added feet/inches conversion, running measurements as logmessage 
'
' Tip: The wizard only exposes a small subset of the possible controls
' and layout that can be achieved on a Property Page.  To find out more
' please refer to the Object Model reference documentation for PPGLayout, PPG
' and CustomProperty
' 
' Tip: Don't be concerned about achieving the exact ordering of the parameters
' because they can easily be reordered in the second phase.
' 
' Tip: Use the "Refresh" option on the Property Page context menu to 
' reload your script changes and re-execute the DefineLayout callback.
' Tip: To add a command to this plug-in, right-click in the 
' script editor and choose Tools > Add Command.
' 
' Tip: To get help on a callback, highlight the callback name
' (for example, "Init", "Define", or "Execute") and press F1.

function XSILoadPlugin( in_reg )
	in_reg.Author = "J Wells"
	in_reg.Name = "MeasurePlugin"
	in_reg.Email = ""
	in_reg.URL = ""
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterProperty "Measure"
	in_reg.RegisterMenu siMenuTbGetPropertyID,"Measure_Menu",false,false
	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
end function

function XSIUnloadPlugin( in_reg )
	dim strPluginName
	strPluginName = in_reg.Name
	Application.LogMessage strPluginName & " has been unloaded.",siVerbose
	XSIUnloadPlugin = true
end function

function Measure_Define( in_ctxt )
	dim oCustomProperty

	set oCustomProperty = in_ctxt.Source
	oCustomProperty.AddParameter2 "dist_in_SI_units",siString,"",,,,,siClassifUnknown,siPersistable
	oCustomProperty.AddParameter2 "dist_in_metres",siString,"",,,,,siClassifUnknown,siPersistable
	oCustomProperty.AddParameter2 "dist_in_ft",siString,"",,,,,siClassifUnknown,siPersistable
	oCustomProperty.AddParameter2 "inches",siString,"",,,,,siClassifUnknown,siPersistable
	oCustomProperty.AddParameter2 "points_picked",siString,"",,,,,siClassifUnknown,siPersistable
	oCustomProperty.AddParameter2 "SI_to_cm",siString,"10",,,,,siClassifUnknown,siPersistable
	Measure_Define = true
end function

function Measure_DefineLayout( in_ctxt )
	dim oLayout,oItem
	set oLayout = in_ctxt.Source
	oLayout.Clear
	
	oLayout.AddGroup "Measure", true
	oLayout.AddButton "Measure"
	oLayout.AddItem "SI_to_cm"
	oLayout.EndGroup
	oLayout.AddGroup "Distance", true
	oLayout.AddItem "points_picked" 
	oLayout.AddItem "dist_in_SI_units"
	oLayout.AddItem "dist_in_metres"
	oLayout.AddRow
	oLayout.AddItem "dist_in_ft"
	oLayout.AddItem "inches"
	oLayout.EndRow
	oLayout.EndGroup
	
	Measure_DefineLayout = true
end function

function Measure_OnInit( )
	'Application.LogMessage "Measure_OnInit called",siVerbose
end function

function Measure_OnClosed( )
	'Application.LogMessage "Measure_OnClosed called",siVerbose
end function

function Measure_Measure_OnClicked( )
	Summed_distance
	'Application.LogMessage "Measure_Measure_OnClicked called",siVerbose
end function

function Measure_distance_OnChanged( )
	Application.LogMessage "Measure_distance_OnChanged called",siVerbose
	dim oParam
	set oParam = PPG.distance
	dim paramVal
	paramVal = oParam.Value
	'Application.LogMessage "New value: " & paramVal,siVerbose
end function

function Measure_Menu_Init( in_ctxt )
	dim oMenu
	set oMenu = in_ctxt.Source
	oMenu.AddCallbackItem "Measure","OnMeasureMenuClicked"
	Measure_Menu_Init = true
end function

function OnMeasureMenuClicked( in_ctxt )
	dim oProp
	dim oParent
	if (Selection.Count = 0) then
		SelectObj "Scene_Root"
	end if
	
	set oParent = Selection.Item(0)
	set oProp = oParent.AddProperty("Measure")
	InspectObj oProp
	OnMeasureMenuClicked = 1
end function

sub Summed_distance

	Dim l_obj1, l_obj2, x1,y1,z1, x2,y2,z2, dx,dy,dz, l_button
	
	'reset values before measuring starts
	count = 0	

	last_x = 0 
	last_y = 0
	last_z = 0
	
	dx = 0
	dy = 0
	dz = 0
	
	sum = 0 
	
	'Continue looping until until a right click

	ratio = CInt(GetValue("Measure.SI_to_cm"))

	do	
	
		PickPosition "Pick position (Ctrl: Snapping)", "Pick position (Ctrl: Snapping)", x1, y1, z1, l_button
		if l_button = 0 then
			exit do 
		end if
	
		if count > 0 then	
			
			dx = abs(last_x - x1)
			dy = abs(last_y - y1)			
			dz = abs(last_z - z1)	
			
			dist = sqr(dx*dx + dy*dy + dz*dz)
	
		end if
		
		last_x = x1
		last_y = y1
		last_z = z1
		
		sum = sum + dist
		
		
		
		count = count + 1
		IF COUNT>1 THEN logmessage "Distance:" & count-1 & "=" & dist & "(in Softimage Units)"
		IF COUNT>1 THEN logmessage "Distance:" & count-1 & "=" & round(dist*ratio/100, 6) & "(in metres)"
		IF COUNT>1 THEN logmessage "Distance:" & count-1 & "=" & round((dist*ratio/100)*3.28, 6) & "(in ft/inches)"
	loop

	feet = Fix((sum*ratio/100)*3.28)
	inches = (round(((sum*ratio/100)*3.28)-feet,2))*12

	SetValue "Measure.dist_in_SI_units", round(sum, 6)
	SetValue "Measure.dist_in_metres", round(sum*ratio/100, 6)
	SetValue "Measure.points_picked", count
	SetValue "Measure.dist_in_ft", feet
	SetValue "Measure.inches", inches
	'Application.LogMessage "Total Distance - SI units: "& round(sum, 6)
	'Application.LogMessage "Total Distance - m: "& round(sum, 6)

end sub
